#ifndef API_OS_VERSION_H
#define API_OS_VERSION_H
#include <stdio.h>
#include <winnt.h>
#include <winbase.h>

enum OS_Type
{
        OS_UnKnow,
        OS_Win32s,
        OS_Win95,
        OS_Win98,
        OS_WinMe,
        OS_WinNT,
        OS_WinNT_Server,
        OS_WinNT_Workstation,
        OS_Win2000_Server,
        OS_Win2000_Advanced ,
        OS_Win2000_Workstation,
        OS_XP_Home,
        OS_XP_Professional,
        OS_WinNET_EnterpriseServer,
        OS_WinNET_WebServer,
        OS_WinNET_Server,
};


class OSVersion
{

public:
        OSVersion();
        ~OSVersion();
        char OS_Name[40];
        char OS_Version[40];
        char OS_Build[40];
        char OS_Additional[40];
        char OS_ServicePack[20];
        char OS_Suite[320];
        char OS_ProductType[40];
        OS_Type OS_TypeID;

};

OSVersion::OSVersion()
{

   memset(OS_Name,'\0',40);
   memset(OS_Version,'\0',40);
   memset(OS_Build,'\0',40);
   memset(OS_Additional,'\0',40);
   memset(OS_ServicePack,'\0',40);
   memset(OS_Suite,'\0',320);
   memset(OS_ProductType,'\0',40);
   OS_TypeID=OS_UnKnow;

   OSVERSIONINFO NorOS;
   OSVERSIONINFOEX AdvOS;
   DWORD Rtn;
   bool AdvInfoAvail;

   NorOS.dwOSVersionInfoSize =sizeof(OSVERSIONINFO);
   Rtn = GetVersionEx(&NorOS);
   AdvInfoAvail=false;
   if(Rtn)
   {
     switch(NorOS.dwMajorVersion)
     {
        case 3: //Windows NT 3.x
          switch(NorOS.dwPlatformId)
          {
             case VER_PLATFORM_WIN32_NT:  //'Windows NT
                 sprintf(OS_Name,"Windows NT %d.%.2d",NorOS.dwMajorVersion,NorOS.dwMinorVersion);
                 OS_TypeID=OS_WinNT;
               break;
             default:
                 sprintf(OS_Name,"Unknown OS Version %d.%.2d",NorOS.dwMajorVersion,NorOS.dwMinorVersion);
               break;
          }
          break;
        case 4: //Windows 95/98/Me/NT4
          switch(NorOS.dwMinorVersion)
          {
             case 0:  //Windows 95/NT4
               switch(NorOS.dwPlatformId)
               {
                  case VER_PLATFORM_WIN32_WINDOWS:  //Windows 95
                     if(strstr(strupr(NorOS.szCSDVersion),"B") !=NULL && strstr(strupr(NorOS.szCSDVersion),"C") !=NULL)
                       strcpy(OS_Name,"Windows 95 OSR2");
                     else
                       strcpy(OS_Name,"Windows 95");
                     OS_TypeID=OS_Win95;
                    break;
                  case VER_PLATFORM_WIN32_NT:  //Windows NT4
                     if(strstr(strupr(NorOS.szCSDVersion),"SERVICE PACK ") != NULL)
                      {
                         sprintf(OS_Name,strstr(strupr(NorOS.szCSDVersion),"SERVICE PACK ")+strlen("SERVICE PACK "));
                         if(atoi(OS_Name) > 6)
                           AdvInfoAvail=true;
                      }
                     strcpy(OS_Name,"Windows NT 4.0");
                     OS_TypeID=OS_WinNT;
                    break;
                  default:
                      sprintf(OS_Name,"Unknown OS Version %d.%.2d Platform %d",NorOS.dwMajorVersion,NorOS.dwMinorVersion,NorOS.dwPlatformId);
                    break;
               }
             case 10: //Windows 98
               if(strstr(strupr(NorOS.szCSDVersion),"A") !=NULL)
                 strcpy(OS_Name,"Windows 98 SE");
               else
                 strcpy(OS_Name,"Windows 98");
               OS_TypeID=OS_Win98;
               break;
             case 90: //Windows ME
               strcpy(OS_Name,"Windows ME");
               OS_TypeID=OS_WinMe;
               break;
             default:
               sprintf(OS_Name,"Unknown OS Version %d.%.2d",NorOS.dwMajorVersion,NorOS.dwMinorVersion);
               break;
          }
          break;
        case 5:   //Windows 2000/XP/.NET Server
          AdvInfoAvail=true;
          switch(NorOS.dwMinorVersion)
          {
             case 0:  //Windows 2000
               strcpy(OS_Name,"Windows 2000");
               break;
             case 1:  //Windows XP
               strcpy(OS_Name,"Windows XP");
               break;
             case 2:  //Windows .NET Server
               strcpy(OS_Name,"Windows .NET");
               break;
             default:
               sprintf(OS_Name,"Unknown OS Version %d.%.2d",NorOS.dwMajorVersion,NorOS.dwMinorVersion);
               break;

          }
          break;
        default:
          AdvInfoAvail = false;
          sprintf(OS_Name,"Unknown OS Version %d.%.2d",NorOS.dwMajorVersion,NorOS.dwMinorVersion);
          break;
     }
   }
   sprintf(OS_Version,"%d.%.2d",NorOS.dwMajorVersion,NorOS.dwMinorVersion);
   sprintf(OS_Build,"%d",NorOS.dwBuildNumber);
   sprintf(OS_Additional,"%s",NorOS.szCSDVersion);

   if(AdvInfoAvail)
   {
     HINSTANCE dllhand=LoadLibrary("kernel32.dll");
     typedef DWORD (WINAPI *GETVERSIONADV)(OSVERSIONINFOEX*);
     GETVERSIONADV GetVersionAdv;
#ifdef UNICODE
     GetVersionAdv=(GETVERSIONADV)GetProcAddress(dllhand,"GetVersionExW");
#else
     GetVersionAdv=(GETVERSIONADV)GetProcAddress(dllhand,"GetVersionExA");
#endif
     AdvOS.dwOSVersionInfoSize=sizeof(OSVERSIONINFOEX);
     Rtn = GetVersionAdv(&AdvOS);
     if(Rtn)
     {
       if(AdvOS.wServicePackMajor > 0 || AdvOS.wServicePackMinor > 0)
         sprintf(OS_ServicePack,"Service Pack %d.%d",AdvOS.wServicePackMajor,AdvOS.wServicePackMinor);
       else
         sprintf(OS_ServicePack,"");
       sprintf(OS_Suite,"");
       if(AdvOS.wSuiteMask & VER_SUITE_BACKOFFICE)
         strcat(OS_Suite,"Microsoft BackOffice components are installed ,");
       if(AdvOS.wSuiteMask & VER_SUITE_COMMUNICATIONS)
         strcat(OS_Suite,"Communications Server installed ,");
       if(AdvOS.wSuiteMask & VER_SUITE_DATACENTER)
         strcat(OS_Suite,"Datacenter Server is installed ,");
       if(AdvOS.wSuiteMask & VER_SUITE_EMBEDDEDNT)
         strcat(OS_Suite,"Embedded NT installed ,");
       if(AdvOS.wSuiteMask & VER_SUITE_SINGLEUSERTS)
         strcat(OS_Suite,"Single User ,");
       if(AdvOS.wSuiteMask & VER_SUITE_SMALLBUSINESS)
         strcat(OS_Suite,"Microsoft Small Business Server is installed ,");
       if(AdvOS.wSuiteMask & VER_SUITE_SMALLBUSINESS_RESTRICTED)
         strcat(OS_Suite,"Microsoft Small Business Server is installed with the restrictive client license in force ,");
       if(AdvOS.wSuiteMask & VER_SUITE_TERMINAL)
         strcat(OS_Suite,"Terminal Services is installed ,");

       if(strlen(OS_Suite) > 2)
         OS_Suite[strlen(OS_Suite)-2]='\0';

       switch(AdvOS.dwMajorVersion)
       {
          case 4:  //NT 4
            switch(AdvOS.wProductType)
            {
               case VER_NT_WORKSTATION:
                 strcpy(OS_ProductType,"Workstation");
                 OS_TypeID=OS_WinNT_Workstation;
                 break;
               case VER_NT_DOMAIN_CONTROLLER:
                 strcpy(OS_ProductType,"Domain Controller");
                 break;
               case VER_NT_SERVER:
                 if(AdvOS.wSuiteMask & VER_SUITE_ENTERPRISE)
                   strcpy(OS_ProductType,"Advanced Server");
                 else
                 {
                   strcpy(OS_ProductType,"Server");
                   OS_TypeID=OS_WinNT_Server;
                 }
                 break;

            }
            break;
          case 5: //Windows 2000/XP/.NET
            switch(AdvOS.dwMinorVersion)
            {
              case 0:  //Win 2000
                switch(AdvOS.wProductType)
                {
                   case VER_NT_WORKSTATION:
                     strcpy(OS_ProductType,"Workstation");
                     OS_TypeID=OS_Win2000_Workstation;
                     break;

                   case VER_NT_DOMAIN_CONTROLLER:
                     strcpy(OS_ProductType,"Domain Controller");
                     break;
                   case VER_NT_SERVER:
                     if(AdvOS.wSuiteMask & VER_SUITE_ENTERPRISE)
                     {
                       strcpy(OS_ProductType,"Advanced Server");
                       OS_TypeID=OS_Win2000_Advanced;
                     }
                     else
                     {
                       strcpy(OS_ProductType,"Server");
                       OS_TypeID=OS_Win2000_Server;
                     }
                     break;
                }
                break;
              case 1:   //Win XP
                switch(AdvOS.wProductType)
                {
                   case VER_NT_WORKSTATION:
                     if(AdvOS.wSuiteMask & VER_SUITE_PERSONAL)
                     {
                       strcpy(OS_ProductType,"Home Edition");
                       OS_TypeID=OS_XP_Home;
                     }
                     else
                     {
                       strcpy(OS_ProductType,"Professional");
                       OS_TypeID=OS_XP_Professional;
                     }
                     break;
                   case VER_NT_DOMAIN_CONTROLLER:
                     strcpy(OS_ProductType,"Domain Controller");
                     break;
                   case VER_NT_SERVER:
                     strcpy(OS_ProductType,"Server");
                     break;
                }
                break;
              case 2:   //Win .NET
                switch(AdvOS.wProductType)
                {
                   case VER_NT_WORKSTATION:
                     sprintf(OS_ProductType,"");
                     break;
                   case VER_NT_DOMAIN_CONTROLLER:
                     strcpy(OS_ProductType,"Domain Controller");
                     break;
                   case VER_NT_SERVER:
                     if(AdvOS.wSuiteMask & VER_SUITE_DATACENTER)
                       strcpy(OS_ProductType,"DataCenter Server");
                     else
                       if(AdvOS.wSuiteMask & VER_SUITE_ENTERPRISE)
                       {
                          strcpy(OS_ProductType,"Enterprise Server");
                          OS_TypeID=OS_WinNET_EnterpriseServer;
                       }
                       else
                         if(AdvOS.wSuiteMask & VER_SUITE_BLADE)
                         {
                           strcpy(OS_ProductType,"Web Server");
                           OS_TypeID=OS_WinNET_WebServer;
                         }
                         else
                         {
                           strcpy(OS_ProductType,"Server");
                           OS_TypeID=OS_WinNET_Server;
                         }
                     break;
                }
                break;
              default:
                strcpy(OS_ProductType,"");
                break;

            }
            break;
          default:
            strcpy(OS_ProductType,"");
            break;
       }
       FreeLibrary(dllhand);
     }
   }
}

OSVersion::~OSVersion()
{
        //TODO: Add your source code here
}

#endif





